# -*- coding: utf-8 -*-

import pprint, sys, os, getopt
from itemset_gen import itemset_gen
from simple_clustring import simple_clustring

def usage() :
    print "\nUsage of item occurrence frequencies-based pattern mining: "
    print "\t-h\t(--help) To show this message."
    print "\t-l\tFull path to the logfile to analyse (mandatory)."
    print "\t-p\tFull path to the directory where the results should be written (mandatory)."
    print "\t-d\t(--debug) To turn on debugging code."
    print "\t-t\t(--threshold) Threshold for when a logline item is considered frequent. Default is 0.001."


def main() :

    # Generate n_itemsets and save to n_itemset file  (run first)
    # Use n_itemsets file to generate final patterns (run second)
    # Split for the convenience of quicker testing
    global cluster_itemsets
    global logfile
    global debug
    global threshold
    global itemsets_file

    itemset_gen(logfile, threshold, itemset_file=itemsets_file, debug=debug)
    
    if cluster_itemsets:
        global patternfile
        patterns = simple_clustring(itemsets_file, patternfile, debug=debug)
        

if __name__ == "__main__" :

    debug = False
    threshold = 0.001   
    cluster_itemsets = True

    logfile = None
    pattern_file_name = 'patterns'
    patternfile = None 
    itemsets_file_name = 'patterns_n-itemsets'
    itemsets_file = None

    argv = sys.argv[1:]

    try:
        opts, args = getopt.getopt(argv, "hdnt:l:p:", ["help", "debug", "generate_itemsets", "threshold=", "no_clustring"])
    except getopt.GetoptError:
        usage()
        sys.exit(2)
    if ( '-l' not in argv ) or ( '-p' not in argv ) :
        usage()
        sys.exit(2)

    for opt, arg in opts :
        if opt in ('-h', '--help') :
            usage()
            sys.exit()
        elif opt in ('-d', '--debug' ) :
            debug = True
        elif opt == '-l' :
            if not os.path.isfile( arg ) :
                print "Logfile '%s' does not exist." % arg
                sys.exit()
            logfile = arg
        elif opt == '-p' :
            if not os.path.isdir( arg ) :
                print "'%s' is not a valid directory." % arg
                sys.exit()
            path = arg
            if arg[-1] != '/':
                path = arg+'/'
            patternfile = path+pattern_file_name
            itemsets_file = path+itemsets_file_name
        elif opt in ('-t', '--threshold') :
            try :
                t = float(arg)
            except :
                print "Threshold must be a decimal number. Using default value %s." % threshold
                t = threshold
            threshold = t
        elif opt in ('-n', '--no_clustring') :
            cluster_itemsets = False 

    main()
