# -*- coding: utf-8 -*-

import pprint

def find_similar_item_patterns(frequent_n_itemsets, debug=False):
    
    patterns = {}
    common_items_factor = 0.6
    
    for size in frequent_n_itemsets.keys():
        for process_name in frequent_n_itemsets[size].keys():
            
            keys= []
            spent_keys = []
            
    
            for key in frequent_n_itemsets[size][process_name].keys():      
                keys.append(key)
            
            for i in keys:
                i_list = i.split()
                i_count = int(frequent_n_itemsets[size][process_name][i])
                k = 0;
                
                if i in spent_keys:
                    continue
                spent_keys.append(i)
                
                pattern_count = i_count
                pattern = i_list
                
                candidates = []
                candidates_count = 0
                max_common_items_fraction = 0
               
                if debug:
                    print "\tLooking at itemset: " 
                    print "\t",i_list
 
                for j in keys:
                    j_list = j.split()
                    j_count = int(frequent_n_itemsets[size][process_name][j])
        
                    k += 1  
        
                    if (i == j) or (j in spent_keys):
                        continue
                    
                    print_ok = 0
                    
                    
                    common_items_fraction = item_comparison_count(i_list,j_list)
    
                    if common_items_fraction >= common_items_factor:
            
                        if common_items_fraction < max_common_items_fraction:
                            if debug :
                                print "\t\tNon-candidate: "
                                print "\t\t\t%s, with %s" % (j, common_items_fraction)
                            continue
                        else:
                            if common_items_fraction == max_common_items_fraction:
                                candidates.append(j)
                                candidates_count += j_count
                                if debug :
                                    print "\t\tCandidate found: "
                                    print "\t\t\t%s, with %s" % (j, common_items_fraction)
    
                            elif common_items_fraction > max_common_items_fraction:
                                max_common_items_fraction = common_items_fraction
                                candidates = [j] # reset the list of candidates
                                candidates_count = j_count # reset the candidate count
                                if debug :
                                    print "\t\tBest match found hitherto: "
                                    print"\t\t\t%s, with %s." % (j, common_items_fraction) 
                
                if len(candidates) > 0:               
                    for candidate in candidates:
                        tmp_pattern = item_comparison(pattern,candidate.split())
                        pattern = tmp_pattern
                        spent_keys.append(candidate)
                        
                    pattern_count += candidates_count
                        
                    
                new_pattern = remove_trailing_stars(pattern)   
                pattern_str = ' '.join(new_pattern)
        
                
                if pattern_str in patterns:    
                    patterns[pattern_str] += pattern_count
                else:
                    patterns[pattern_str] = pattern_count
                
    return patterns

def item_comparison(s1,s2): # s1 og s2 er lister

    common = []
       
    for k in range(len(s1)):
        a,b = s1[k], s2[k]
        
        if (a == b):
            #print "    word \"%s\" is identical in both strings" % a
            common.append(a)
        else:
            common.append('.*')
    
    return common
    
def item_comparison_count(s1,s2): # s1 og s2 er lister
   
   count = 0.0    
   l = len(s1)
   
   for k in range(l):
       a,b = s1[k], s2[k]
       
       if (a != b):
           continue
       count += 1.0
   
   return (count/l)

def remove_trailing_stars(list):
    msg = []
    prev = ''
    for item in list:
        if (prev == '.*') and (item == '.*'):
            continue
        msg.append(item)    
        prev = item   
        
    return msg


def save_patterns(pattern_file, patterns_dict, debug=False):
    fw = open(pattern_file, 'w+')
    
    pat = []
    
    for key, value in patterns_dict.items():   
        s = key.replace('.*','')
        k = s.replace('  ',' ')
        l = k + ' ' + str(value) + '\n'
        pat.append(l)
    
    patterns = sorted(pat) 
    
    
    for pattern in patterns:
        fw.writelines(pattern)
    fw.close()

def simple_clustring(itemset_file, pattern_file, debug=False):
    
    f = open(itemset_file, 'r')
    
    itemsets = {}
    
    for ln in f:
        line = ln.decode('utf-8', 'ignore')
        l = line.split()
        process_name = l[0]
        count = l.pop()
        size = len(l)
        key = ' '.join(l) 
        
        
#        print "Itemset ", l,
#        print " with size ", size,
#        print " and count", count
        
        if size not in itemsets:
            itemsets[size] = {}
        if process_name not in itemsets[size]:
            itemsets[size][process_name] = {}
        itemsets[size][process_name][key] = count
    
 #   pprint.pprint(itemsets[12])
    
    
    
    f.close()
        
    patterns = find_similar_item_patterns(itemsets, debug=debug)
      
    save_patterns(pattern_file, patterns, debug=debug)

    print "Patterns written to file '%s'." % pattern_file
    
