# -*- coding: utf-8 -*-

from tree_graph import save_graph
from TreeNode2 import TreeNode
from pygraphviz import *
import libxml2, libxslt, sys

file_path = ''


def initialise_graph() :
    g = AGraph( ranksep='0.2 equally' )
    g.node_attr['shape'] = 'box'
    g.node_attr['style'] = 'filled'
    g.node_attr['fillcolor'] = 'orange'

    return g


def insertion_examining_parent() : 
    global path

    g = initialise_graph()
    
    g.add_node(1, label='A')
    g.add_node(2, label='*')
    g.add_node(3, label='B')
    g.add_node(4, label='C', shape='note', fillcolor='red')
    g.add_node(5, label='K')
    g.add_node(6, label='L')
    g.add_node(7, label='M', shape='note', fillcolor='red')

    g.add_edge(1, 2, label='2')
    g.add_edge(2, 3, label='2')
    g.add_edge(3, 4, label='2')
    g.add_edge(1, 5, label='2')
    g.add_edge(5, 6, label='2')
    g.add_edge(6, 7, label='2')

    save_graph(g, path+'insertion_examin_parent1'+'.svg')

    g2 = initialise_graph()

    g2.add_node(8, label='A')
    g2.add_node(9, label='K')
    g2.add_node(10, label='B')
    g2.add_node(11, label='C')
    
    g2.add_edge( 8, 9 )
    g2.add_edge( 9,10 )
    g2.add_edge(10,11 )

    save_graph(g2, path+'insertion_examin_parent2'+'.svg')

    g.add_node(10, label='B')
    g.add_node(11, label='C', shape='note', fillcolor='red')

    edge = g.get_edge( 1, 5 )
    edge.attr['label'] = '3'
    g.add_edge(5, 10, label='1')
    g.add_edge(10, 11, label='1')

    save_graph(g, path+'insertion_examin_parent3'+'.svg')

 
    g3 = initialise_graph()
    
    g3.add_node(1, label='A')
    g3.add_node(2, label='*')
    g3.add_node(3, label='B')
    g3.add_node(4, label='C', shape='note', fillcolor='red')
    g3.add_node(5, label='K')
    g3.add_node(6, label='L')
    g3.add_node(7, label='M', shape='note', fillcolor='red')

    g3.add_edge(1, 2, label='3')
    g3.add_edge(2, 3, label='3')
    g3.add_edge(3, 4, label='3')
    g3.add_edge(1, 5, label='2')
    g3.add_edge(5, 6, label='2')
    g3.add_edge(6, 7, label='2')

    save_graph(g3, path+'insertion_examin_parent4'+'.svg')
    
    #graph.add_node(id, label=root.label, fillcolor='red')
    #graph.add_edge(parent_id, id, label=e_lab)
    #graph.add_node(id, label=lab, shape='note', fillcolor='red')    
    #save_graph( graph, file )


def hls() :
    
    g = initialise_graph()

    g.add_node(1, label='A')
    g.add_node(2, label='S')
    g.add_node(3, label='D')
    g.add_node(4, label='K', shape='note', fillcolor='red')
    g.add_node(5, label='R', shape='note', fillcolor='red')
    g.add_node(8, label='*')
    g.add_node(6, label='D', shape='note', fillcolor='red')
    g.add_node(7, label='K', shape='note', fillcolor='red')

    g.add_edge(1, 2, label='2')
    g.add_edge(2, 3, label='2')
    g.add_edge(3, 4, label='1')
    g.add_edge(3, 5, label='1')
    g.add_edge(1, 8, label='4')
    g.add_edge(8, 6, label='4')
    g.add_edge(6, 7, label='2')

    save_graph(g, path+'hls'+'.svg')


def releasing_hls() :
    
    g = initialise_graph()

    g.add_node(1, label='A')
    g.add_node(2, label='S')
    g.add_node(3, label='D')
    g.add_node(4, label='K', shape='note', fillcolor='red')
    g.add_node(5, label='R', shape='note', fillcolor='red')
    g.add_node(6, label='D', shape='note', fillcolor='red')
    g.add_node(7, label='K', shape='note', fillcolor='red')

    g.add_edge(1, 2, label='2')
    g.add_edge(2, 3, label='2')
    g.add_edge(3, 4, label='1')
    g.add_edge(3, 5, label='1')
    g.add_edge(1, 6, label='4')
    g.add_edge(6, 7, label='2')

    save_graph(g, path+'release_hls1'+'.svg')

    edge16 = g.get_edge(1, 6)
    edge16.attr['label'] = '3'
    edge67 = g.get_edge(6,7)
    edge67.attr['label'] = '1'

    g.add_node(8, label='D')
    g.add_node(9, label='K', shape='note', fillcolor='red')
    g.add_edge(1, 8, label='1')
    g.add_edge(8, 9, label='1')

    save_graph(g, path+'release_hls2'+'.svg')

    edge12 = g.get_edge(1,2)
    edge23 = g.get_edge(2,3)
    edge34 = g.get_edge(3,4)
    edge12.attr['label'] = '3'
    edge23.attr['label'] = '3'
    edge34.attr['label'] = '2'

    g.delete_edge(1, 8)
    g.delete_edge(8, 9)
    g.delete_node(8)
    g.delete_node(9)

    save_graph(g, path+'release_hls3'+'.svg')

    g.add_node(10, label='T')
    g.add_edge(1,10, label='0')

    save_graph(g, path+'release_hls4'+'.svg')

    g.add_node(11, label='D', shape='note', fillcolor='red' )
    g.add_edge(1,11, label='2')

    node6 = g.get_node(6)
    edge16 = g.get_edge(1,6)
    edge16.attr['label'] = '1'
    node6.attr['fillcolor'] = 'orange'
    node6.attr['shape'] = 'box'

    save_graph(g, path+'release_hls5'+'.svg')

    edge110 = g.get_edge(1,10)
    edge110.attr['label'] = '1'
    g.delete_edge(1,6)
    g.add_edge(10, 6, label='1')

    save_graph(g, path+'release_hls6'+'.svg')

    g.add_node(12,label='D', shape='note', fillcolor='red')
    g.add_edge(1,12,label='1')
    edge111 = g.get_edge(1, 11)
    edge111.attr['label'] = '1'

    save_graph(g, path+'release_hls7'+'.svg')

    edge12 = g.get_edge(1,2)
    edge12.attr['label'] = '4'
    edge23 = g.get_edge(2,3)
    edge23.attr['label'] = '4'
    node3 = g.get_node(3)
    node3.attr['fillcolor'] = 'red'
    node3.attr['shape'] = 'note'

    g.delete_edge( 1, 11 )
    g.delete_node(11)

    save_graph(g, path+'release_hls8'+'.svg')
   
    g.delete_edge( 1, 12 )
    g.delete_node(12)

    edge110 = g.get_edge(1,10)
    edge110.attr['label'] = '2'
    edge106 = g.get_edge(10, 6)
    edge106.attr['label'] = '2'
    node6 = g.get_node(6)
    node6.attr['fillcolor'] = 'red'
    node6.attr['shape'] = 'note'
    
    save_graph(g, path+'release_hls9'+'.svg')

def releasing_hls_paths_changing() :
    
    g = initialise_graph()

    g.add_node(1, label='A')
    g.add_node(2, label='B')
    g.add_node(3, label='C')
    g.add_node(4, label='D', shape='note', fillcolor='red')
    g.add_node(5, label='E')
    g.add_node(6, label='F', shape='note', fillcolor='red')

    g.add_edge(1,2, label='10')
    g.add_edge(2,3, label='10')
    g.add_edge(3,4, label='10')
    g.add_edge(4,5, label='5')
    g.add_edge(5,6, label='5')

    save_graph(g, path+'releasing_hls_paths_changing1'+'.svg')

    edge45 = g.get_edge(4,5)
    edge45.attr['label'] = '8'
    node5 = g.get_node(5)
    node5.attr['fillcolor'] = 'red'
    node5.attr['shape'] = 'note'

    save_graph(g, path+'releasing_hls_paths_changing2'+'.svg')

    g.add_node(7, label='G')
    g.add_edge(4,7, label='2')

    save_graph(g, path+'releasing_hls_paths_changing3'+'.svg')

def merge() :
    
    g = initialise_graph()

    g.add_node(0, label='R')
    g.add_node(11, label='A')
    g.add_node(12, label='A')
    g.add_node(13, label='A')
    g.add_node(21, label='B')
    g.add_node(22, label='B', shape='note', fillcolor='red')
    g.add_node(23, label='B')
    g.add_node(31, label='G', shape='note', fillcolor='red')
    g.add_node(33, label='D')
    g.add_node(43, label='E', shape='note', fillcolor='red')

    g.add_edge(0,11, label='2')
    g.add_edge(0,12, label='2')
    g.add_edge(0,13, label='2')
    g.add_edge(11,21, label='2')
    g.add_edge(21,31, label='2')
    g.add_edge(12,22, label='2')
    g.add_edge(13,23, label='2')
    g.add_edge(23,33, label='2')
    g.add_edge(33,43, label='2')

    save_graph(g, path+'merge1'+'.svg')

    g.delete_edge(21,31)
    g.add_edge(22,31, label='2')

    save_graph(g, path+'merge2'+'.svg')
   
    g.delete_edge(11,21)
    g.delete_node(21)
    edge1222 = g.get_edge(12,22)
    edge1222.attr['label'] = '4'

    save_graph(g, path+'merge3'+'.svg')
    sys.exit()
    g.delete_edge(0,11)
    g.delete_node(11)
    edge012 = g.get_edge(0,12)
    edge012.attr['label'] = '4'

    save_graph(g, path+'merge4'+'.svg')

    g.delete_edge(22,31)
    g.add_edge(23, 31, label='2')
    
    save_graph(g, path+'merge5'+'.svg')

    g.delete_edge(12,22)
    g.delete_node(22)
    edge1323 = g.get_edge(13,23)
    edge1323.attr['label'] = '6'
    node23 = g.get_node(23)
    node23.attr['fillcolor'] ='red'
    node23.attr['shape'] = 'note'

    save_graph(g, path+'merge6'+'.svg')

    g.delete_edge(0,12)
    g.delete_node(12)
    edge013 = g.get_edge(0,13)
    edge013.attr['label'] = '6'

    save_graph(g, path+'merge7'+'.svg')

def simple() :
    
    g = initialise_graph()

    g.add_node(1, label='A')
    g.add_node(2, label='B')
    g.add_node(3, label='C')
    g.add_node(4, label='D', shape='note', fillcolor='red')

    g.add_edge(1,2, label='2')
    g.add_edge(2,3, label='2')
    g.add_edge(3,4, label='2')
    
    save_graph(g, path+'simple'+'.svg')

def stem_illustration() :
    
    g = initialise_graph()

    g.add_node(0, label='root')
    g.add_node(1, label='A')
    g.add_node(2, label='B')
    g.add_node(3, label='C')
    g.add_node(4, label='D', shape='note', fillcolor='red')

    g.add_edge(0,1, label='1')
    g.add_edge(1,2, label='1')
    g.add_edge(2,3, label='1')
    g.add_edge(3,4, label='1')
    
    save_graph(g, path+'simple_with_root'+'.svg')

    g.delete_edge(0,1)
    g.delete_node(0)

    edge12 = g.get_edge(1,2)
    edge23 = g.get_edge(2,3)
    edge34 = g.get_edge(3,4)
    edge12.attr['label'] = ''
    edge23.attr['label'] = ''
    edge34.attr['label'] = ''
    node3 = g.get_node(3)
    node3.attr['label'] = 'G'
    node4 = g.get_node(4)
    node4.attr['label'] = 'H'
    node4.attr['shape'] = 'box'
    node4.attr['fillcolor'] = 'orange'

    save_graph(g, path+'simple_insert'+'.svg')

def simple_insertion() :
    g = initialise_graph()

    g.add_node(1, label='A')
    g.add_node(2, label='B')
    g.add_node(3, label='C')
    g.add_node(4, label='H')

    g.add_edge(1,2)
    g.add_edge(2,3)
    g.add_edge(3,4)

    save_graph(g, path+'simple_insert2'+'.svg')

    g2 = initialise_graph()

    g2.add_node(1, label='A')
    g2.add_node(2, label='B')
    g2.add_node(3, label='C')
    g2.add_node(4, label='*', shape='note', fillcolor='red')

    g2.add_edge(1,2, label='3')
    g2.add_edge(2,3, label='3')
    g2.add_edge(3,4, label='3')
    
    save_graph(g2, path+'simple_merge_result'+'.svg')


def branch_split() :
    
    g = initialise_graph()

    g.add_node(1, label='A')
    g.add_node(2, label='H')
    g.add_node(3, label='D')
    g.add_node(4, label='E', shape='note', fillcolor='red')
    g.add_node(5, label='B')
    g.add_node(6, label='C', shape='note', fillcolor='red')

    g.add_edge(1,2, label='4')
    g.add_edge(2,3, label='2')
    g.add_edge(3,4, label='2')
    g.add_edge(2,5, label='2')
    g.add_edge(5,6, label='2')

    save_graph(g, path+'branch_split1'+'.svg')

    g.add_node(7, label='H')
    g.add_edge(1,7, label='2')
    g.delete_edge(2,5)
    g.add_edge(7,5, label='2')
    edge12 = g.get_edge(1,2)
    edge12.attr['label'] = '2'
    
    save_graph(g, path+'branch_split2'+'.svg')
    
    node7 = g.get_node(7)
    node7.attr['label'] = '*'
    edge17 = g.get_edge(1,7)
    edge75 = g.get_edge(7,5)
    edge56 = g.get_edge(5,6)
    edge17.attr['label'] = '3'
    edge75.attr['label'] = '3'
    edge56.attr['label'] = '3'

    save_graph(g, path+'branch_split3'+'.svg')


def remove_stars() :
    
    g = initialise_graph()

    g.add_node(1, label='R')
    g.add_node(2, label='*')
    g.add_node(3, label='A')
    g.add_node(4, label='B')
    g.add_node(5, label='G', shape='note', fillcolor='red')
    g.add_node(6, label='A')
    g.add_node(7, label='B')
    g.add_node(8, label='*', shape='note', fillcolor='red')
    g.add_node(9, label='*')
    g.add_node(10, label='*')
    g.add_node(14, label='A')
    g.add_node(11, label='B')
    g.add_node(12, label='D')
    g.add_node(13, label='E', shape='note', fillcolor='red')

    g.add_edge(1,2, label='2')
    g.add_edge(2,3, label='2')
    g.add_edge(3,4, label='2')
    g.add_edge(4,5, label='2')
    g.add_edge(1,6, label='2')
    g.add_edge(6,7, label='2')
    g.add_edge(7,8, label='2')
    g.add_edge(1,9, label='2')
    g.add_edge(9,10, label='2')
    g.add_edge(10,14, label='2')
    g.add_edge(14,11, label='2')
    g.add_edge(11,12, label='2')
    g.add_edge(12,13, label='2')

    save_graph(g, path+'remove_stars'+'.svg')


def total_example() :
    g = initialise_graph()

    g.add_node(1, label='A')
    g.add_node(2, label='B')
    g.add_node(3, label='C')
    g.add_node(4, label='D')
    g.add_node(5, label='E', shape='note', fillcolor='red')
    g.add_node(6, label='R')
    g.add_node(7, label='S', shape='note', fillcolor='red')
    g.add_node(8, label='B')
    g.add_node(9, label='V')
    g.add_node(10, label='L', shape='note', fillcolor='red')


    g.add_edge(1,2, label='2')
    g.add_edge(2,3, label='2')
    g.add_edge(3,4, label='1')
    g.add_edge(4,5, label='1')
    g.add_edge(3,6, label='1')
    g.add_edge(6,7, label='1')
    g.add_edge(1,8, label='1')
    g.add_edge(8,9, label='1')
    g.add_edge(9,10, label='1')

    save_graph(g, path+'total_example1'+'.svg',500)

    g.add_node(11, label='C')
    g.add_edge(2,11,label='1')
    g.delete_edge(3,6)
    g.add_edge(11,6,label='1')

    g.get_edge(2,3).attr['label'] = '1'
    
    save_graph(g, path+'total_example2'+'.svg',500)

    g.get_edge(1,2).attr['label'] = '3'
    g.get_edge(2,3).attr['label'] = '2'
    g.get_edge(3,4).attr['label'] = '2'
    g.get_edge(4,5).attr['label'] = '2'

    g.get_node(3).attr['label'] = '*'

    save_graph(g, path+'total_example3'+'.svg',500)

    g.delete_edge(2,3)
    g.delete_edge(3,4)
    g.delete_node(3)
    g.add_edge(2,4,label='2')
    # Triks
    g.delete_edge(2,11)
    g.add_edge(2,11,label='1')

    save_graph(g, path+'total_example4'+'.svg',500)

    g.get_edge(1,2).attr['label'] = '4'
    g.delete_edge(1,8)
    g.delete_edge(8,9)
    g.delete_node(8)
    g.add_edge(2,9,label='1')
    
    save_graph(g, path+'total_example5'+'.svg',500)
       
    g.get_edge(2,4).attr['label'] = '1'
    g.get_edge(4,5).attr['label'] = '1'
 
    g.get_edge(2,11).attr['label'] = '2'
    g.add_node(12,label='D')
    g.add_node(13,label='E', shape='note', fillcolor='red')
    g.add_edge(12,13,label='1')
    g.add_edge(11,12,label='1')    

    save_graph(g, path+'total_example6'+'.svg',500)
 
    g2 = initialise_graph()
    
    g2.add_node(1, label='A')
    g2.add_node(2, label='B')
    g2.add_node(3, label='K')
    g2.add_node(4, label='D')
    g2.add_node(5, label='E')
    
    g2.add_edge(1,2)
    g2.add_edge(2,3)
    g2.add_edge(3,4)
    g2.add_edge(4,5)

    save_graph(g2, path+'total_example_logline'+'.svg',500)

if __name__ == '__main__' :


    path = ''

    if len( sys.argv[1:] ) != 1:
        print "I take one arguments; the name of the example to generate."

    example = sys.argv[1]

    if example == 'simple' :
        simple()
    elif example == 'total_example' :
        total_example()
    elif example == 'branch_split' :
        branch_split()
    elif example == 'hls' :
        hls()
    elif example == 'remove_stars' :
        remove_stars()
    elif example == 'simple_insertion' :
        simple_insertion()
    elif example == 'stem_illustration' :
        stem_illustration()
    elif example == 'insertion_examining_parent' :
        insertion_examining_parent()
    elif example == 'releasing_hls' :
        releasing_hls()
    elif example == 'releasing_hls_paths_changing' :
        releasing_hls_paths_changing()
    elif example == 'merge' :
        merge()

