# -*- coding: utf-8 -*-

import sys, os.path, pickle
from subprocess import call, Popen

def main() :
    if len( sys.argv[1:] ) != 3:
        print "I take three arguments. The path to the log, the path to the resulting patterns, and the path to a file with things to ignore."

    #print sys.argv[1:] # or all parameters
    log = sys.argv[1]
    patterns = sys.argv[2]
    spam_file = sys.argv[3]

    not_found, pattern_sum, no_patterns = read_patterns( patterns, log )
    #for size, list in pattern_dict.items():
    #    for elem in list:
    #        print elem


    spam_sum = calculate_no_spam( log, spam_file )
    log_size = calculate_log_size( log )
    non_spam_loglines = ( log_size - spam_sum )
    
    # Here comes the report.

    print "\nLogfile contains %i lines." % log_size

    if not not_found :
        print "\tOK :    All patterns seems to be correct. Total number of patterns: %i." % ( no_patterns )
    else :
        print "\tERROR:  %i of %i patterns could not be found: " % ( len( not_found ), no_patterns )
        print "\t\tNote that patterns containing regular expression metacharacters ( +,*,&,^ etc ) may cause the verification of a pattern to fail.'
        for pattern in not_found:
            print "\t\t", pattern

    print "\tSum of all patterns is %i. ( Should be close to the number of lines in the log: %i )" % ( pattern_sum, log_size )
    print "\t\t( %s (possibly not unique) spam lines found and ignored ) " % spam_sum





def calculate_log_size( file ) :
    " Size, in terms of number of loglines. "

    command = "wc -l %s" % ( file )
    r = os.popen(command)
    res = r.readlines()[0].strip()
    res_list = res.split()
    no_lines = int ( res_list[0] )
    
    return no_lines

def calculate_no_spam( file, spam_file ) :
    
    known_spam = []

    sf = open( spam_file, 'r' )
    for spamline in sf :
        known_spam.append( spamline )
    sf.close()
    
    sum = 0

    for spam_pattern in known_spam :
        command = "egrep -c '%s' %s " % ( spam_pattern, file )
        r = os.popen(command)
        res = int( r.readlines()[0].strip() )

        sum += res

    return sum
    
def read_patterns( pattern_file, log ) :
    
    p_file = open( pattern_file,'r')
    
    not_found = []
    pattern_sum = 0
    no_patterns = 0

    for pt in p_file :

        pattern = pt.split()
        count = int( pattern.pop() )
        
        pattern_sum += count
        no_patterns += 1
        
        # Grep after the pattern in the log file
        search_pattern = '.*'.join( pattern )
        # Simply verify by finding the first match in the logfile
        command = "egrep -c -m 1 '%s' %s " % ( search_pattern, log )
        r = os.popen(command)
        res = int( r.readlines()[0].strip() )
       
        if res == 0 :
            not_found.append( pattern )

    p_file.close()
    
    return not_found, pattern_sum, no_patterns


if __name__ == "__main__":
    main()
